# TODO: use system libassuan 2 instead of included libassuan 1
#
# Conditional build:
%bcond_without	gtk	# without GTK+ 1.x dialog
%bcond_without	gtk2	# without GTK+ 2 dialog
%bcond_without	qt	# without Qt dialog
%bcond_without	qt4	# without Qt4 dialog
#
Summary:	Simple PIN or passphrase entry dialogs
Summary(pl.UTF-8):	Proste kontrolki dialogowe do wpisywania PIN-ów lub haseł
Name:		pinentry
Version:	0.8.3
Release:	1
License:	GPL v2+
Group:		Applications
Source0:	ftp://ftp.gnupg.org/gcrypt/pinentry/%{name}-%{version}.tar.bz2
# Source0-md5:	2ae681cbca0d9fb774b2c90b11ebf56c
Patch0:		%{name}-system-assuan.patch
Patch1:		%{name}-info.patch
Patch2:		%{name}-am.patch
Patch3:		0001-Fix-qt4-pinentry-window-created-in-the-background.patch
URL:		http://www.gnupg.org/
%{?with_qt4:BuildRequires:	QtGui-devel}
BuildRequires:	autoconf >= 2.57
BuildRequires:	automake >= 1:1.10
BuildRequires:	gettext-devel
%{?with_gtk:BuildRequires:	gtk+-devel >= 1.2.0}
%{?with_gtk2:BuildRequires:	gtk+2-devel >= 2:2.4.0}
#BuildRequires:	libassuan-devel
BuildRequires:	libcap-devel
BuildRequires:	libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	pkgconfig
%{?with_qt:BuildRequires:	qt-devel}
%{?with_qt4:BuildRequires:	qt4-build}
BuildRequires:	texinfo
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is a collection of simple PIN or passphrase entry dialogs which
utilize the Assuan protocol as described by the aegypten project; see
http://www.gnupg.org/aegypten/ for details. Base package contains
curses-based dialog.

%description -l pl.UTF-8
Jest to zestaw prostych kontrolek dialogowych do wpisywania PIN-ów lub
haseł, używające protokołu Assuan opisanego w projekcie aegypten;
więcej szczegółów pod adresem http://www.gnupg.org/aegypten/.
Podstawowy pakiet zawiera kontrolkę opartą na curses.

%package gtk
Summary:	Simple PIN or passphrase entry dialog for GTK+ 1.x
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla GTK+ 1.x
Group:		X11/Applications

%description gtk
Simple PIN or passphrase entry dialog for GTK+ 1.x.

%description gtk -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla GTK+
1.x.

%package gtk2
Summary:	Simple PIN or passphrase entry dialog for GTK+ 2
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla GTK+ 2
Group:		X11/Applications
Requires:	gtk+2 >= 2:2.4.0

%description gtk2
Simple PIN or passphrase entry dialog for GTK+ 2.

%description gtk2 -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla GTK+ 2.

%package qt
Summary:	Simple PIN or passphrase entry dialog for Qt
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Qt
Group:		X11/Applications

%description qt
Simple PIN or passphrase entry dialog for Qt.

%description qt -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Qt.

%package qt4
Summary:	Simple PIN or passphrase entry dialog for Qt4
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Qt4
Group:		X11/Applications

%description qt4
Simple PIN or passphrase entry dialog for Qt4.

%description qt4 -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Qt4.

%prep
%setup -q
#patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%if %{with qt4}
cd qt4
%{_bindir}/moc-qt4 pinentrydialog.h  -o pinentrydialog.moc
%{_bindir}/moc-qt4 qsecurelineedit.h -o qsecurelineedit.moc
cd ..
%endif

#%{__rm} assuan/*.h

%build
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
CPPFLAGS="%{rpmcppflags} -I/usr/include/ncurses"
%configure \
	--enable-maintainer-mode \
	--enable-fallback-curses \
	--enable-pinentry-curses \
	--enable-pinentry-gtk%{!?with_gtk:=no} \
	--enable-pinentry-gtk2%{!?with_gtk2:=no} \
	--enable-pinentry-qt%{!?with_qt:=no} \
	--enable-pinentry-qt4%{!?with_qt4:=no} \
	--with-qt-includes=%{_includedir}/qt

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} $RPM_BUILD_ROOT%{_bindir}/pinentry
cat >$RPM_BUILD_ROOT%{_bindir}/pinentry <<'EOF'
#!/bin/sh

if [ -n "$PINENTRY_PROGRAM" ]; then
	exec $PINENTRY_PROGRAM "$@"
elif [ -z "$DISPLAY" ]; then
	exec %{_bindir}/pinentry-curses "$@"
elif [ -x %{_bindir}/pinentry-gtk-2 ]; then
	exec %{_bindir}/pinentry-gtk-2 "$@"
elif [ -x %{_bindir}/pinentry-gtk ]; then
	exec %{_bindir}/pinentry-gtk "$@"
elif [ -x %{_bindir}/pinentry-qt4 ]; then
	exec %{_bindir}/pinentry-qt4 "$@"
elif [ -x %{_bindir}/pinentry-qt ]; then
	exec %{_bindir}/pinentry-qt "$@"
else
	exec %{_bindir}/pinentry-curses "$@"
fi
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%postun	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS README THANKS TODO
%attr(755,root,root) %{_bindir}/pinentry
%attr(755,root,root) %{_bindir}/pinentry-curses
%{_infodir}/pinentry.info*

%if %{with gtk}
%files gtk
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-gtk
%endif

%if %{with gtk2}
%files gtk2
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-gtk-2
%endif

%if %{with qt}
%files qt
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-qt
%endif

%if %{with qt4}
%files qt4
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-qt4
%endif
%changelog
* Tue May 07 2013 Jakub Bogusz <qboosh@pld-linux.org> c9d6e30
- updated to 0.8.3
- added am patch (fixes build with automake 1.13+)

* Wed Aug 29 2012 Jakub Bogusz <qboosh@pld-linux.org> f5f6363
- updated to 0.8.2

* Tue Jan 10 2012 lisu <lisu@pld-linux.org> 7fca008
- no more separated libtinfo(w)

* Fri Dec 16 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 7cabb71
- rel 3; activate properly

* Thu Sep 01 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> b3ee5b1
- release 2

* Sat Jan 22 2011 sparky <sparky@pld-linux.org> 941fba9
- fixed linking
- restored rpmcppflags

* Sat Jan 08 2011 Jakub Bogusz <qboosh@pld-linux.org> b8ee488
- updated to 0.8.1
- stick to included libassuan 1.x until sb updates pinentry code for new libassuan

* Sun May 16 2010 arvenil <arvenil@pld-linux.org> 461907c
- up to 0.8.0

* Tue Mar 30 2010 shadzik <shadzik@pld-linux.org> 67d1caa
- make it use libassuan1
- rel 2

* Tue Mar 30 2010 shadzik <shadzik@pld-linux.org> 8d84fd6
- adjust for libassuan1

* Mon Nov 30 2009 sparky <sparky@pld-linux.org> d7f63b9
- for qt4: added BR: qt4-build
- BR: QtGui-devel and regenerate moc only if compiled with qt4
- BR: gettext-devel

* Sat Jul 25 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 0a2f23f
- up to 0.7.6; qt4 version available now

* Sat Mar 07 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 651af08
- rel 4; add pinentry-qt4 to pinentry script

* Mon Nov 17 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> f37d66a
- rel 3; fix pinentry script

* Tue Aug 26 2008 Jakub Bogusz <qboosh@pld-linux.org> 7499c65
- user-configurable first

* Tue Aug 26 2008 Jakub Bogusz <qboosh@pld-linux.org> 63aa9b9
- release 2

* Tue Aug 26 2008 Jakub Bogusz <qboosh@pld-linux.org> 0269451
- use privimive selector instead of (not present or not configurable) /usr/bin/pinentry symlink

* Mon May 12 2008 Jakub Bogusz <qboosh@pld-linux.org> b8975ff
- updated to 0.7.5
- added types patch

* Mon May 12 2008 Jakub Bogusz <qboosh@pld-linux.org> 2796c1d
- fix conflicting types

* Tue Jan 29 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> 8ef43f8
- rel 2

